--
-- StopBuyStuff
--
-- @author  ANDR55
-- Version 0.1
-- @date 23.10.2013


StopBuyStuff = {};


function StopBuyStuff:loadMap(name)

	print("loadMap - StopBuyStuff")

	
	Sprayer.updateTick       = Utils.appendedFunction(Sprayer.updateTick,       StopBuyStuff.updateTick_Sprayer);
	SowingMachine.updateTick = Utils.appendedFunction(SowingMachine.updateTick, StopBuyStuff.updateTick_Sprayer);
	
	
	local olddriveInDirection = AIVehicleUtil.driveInDirection;

	AIVehicleUtil.driveInDirection = function(self, dt, steeringAngleLimit, acceleration, slowAcceleration, slowAngleLimit, allowedToDrive, moveForwards, lx, lz, maxSpeed, slowDownFactor)
	
		if self.StopBuyStuff_isHirableBlocked == true then
			return;
			--allowedToDrive = false;
		end;
	
		olddriveInDirection(self, dt, steeringAngleLimit, acceleration, slowAcceleration, slowAngleLimit, allowedToDrive, moveForwards, lx, lz, maxSpeed, slowDownFactor);
	end;
end;

function StopBuyStuff:print_r(t, subload, indent)
  local indent=indent or ''
  --local subload = false
  for key,value in pairs(t) do
    print(indent,'[',tostring(key),']')
	--if key ~= "hotspots" and key ~= "OrgStatsPages" and key ~= "statname" then
	if key ~= "localConnection" then
		if type(value)=="table" and subload == true then 
			print(':\n') self:print_r(value,indent..'\t')
		else 
			print(' = ',tostring(value),'\n')
		end
	end
  end
end

function StopBuyStuff:updateTick_Sprayer(dt)


	--if self:getIsActive() then
	
		
		--and self.allowsSpraying then

--			print(self.isServer)
--			print(self.fillLevel <= 0)
--			print(self:getIsHired())
		
			--[[
            local fillType = self.currentFillType;
            if fillType == Fillable.FILLTYPE_UNKNOWN then
                fillType = self:getFirstEnabledFillType();
            end
			]]--
	
			--

			
		if self.isServer then
			
			if self:getIsTurnedOn() then
		
				
					--self.isHired = false;
					
				if self:getIsHired() then
					
					if self.StopBuyStuff_BuyMode == "wait" then
						
						if self.StopBuyStuff_lastFillLevel == nil then
							self.StopBuyStuff_lastFillLevel = self.fillLevel;
						end;
						
						if self:getCapacity() > 1 then --Güllegrubber haben eine Kapazität von 1... 
							if self.fillLevel <= 0 then
							
								local tractor = StopBuyStuff:GetTractor(self);
							
								if not tractor.StopBuyStuff_isHirableBlocked then

									print("Abschalten".." - "..self.configFileName.." - "..tostring( self.fillLevel).." - "..tostring( self:getCapacity()));
									
									
									if tractor ~= nil then
										--tractor:dismiss();
										--tractor:stopAITractor();

										tractor.StopBuyStuff_isHirableBlocked = true;
									end;
									
									self.StopBuyStuff_lastFillLevel = self.fillLevel;
								end;
							else
								local tractor = StopBuyStuff:GetTractor(self);
							
								if tractor.StopBuyStuff_isHirableBlocked then
									
									if self.fillLevel ~= nil and self.fillLevel <= self.StopBuyStuff_lastFillLevel then
										print("Anschalten".." - "..self.configFileName.." - "..tostring( self.fillLevel).." - "..tostring( self:getCapacity()));
										
										
										if tractor ~= nil then
											tractor.StopBuyStuff_isHirableBlocked = false;
										end;
									else
										print("Beladevorgang".." - "..self.configFileName.. " - "..tostring(self.fillLevel).." - "..tostring(self.StopBuyStuff_lastFillLevel));
									
									end;
									
									self.StopBuyStuff_lastFillLevel = self.fillLevel;
								end;
							end;
						end;
					else
					
						local tractor = StopBuyStuff:GetTractor(self);
					
						if tractor.StopBuyStuff_isHirableBlocked then
							tractor.StopBuyStuff_isHirableBlocked = false;
						end;
					
					end;
				end;
			end;
		end;
	
	
	--end;



end;

function StopBuyStuff:GetTractor(veh)

	local ok = false;
	local user = "";
	

	while ok == false and veh ~= nil do
		--print(veh.configFileName.." - "..tostring( SpecializationUtil.hasSpecialization(Steerable, veh.specializations)).." - "..tostring(veh.specializations));
		if SpecializationUtil.hasSpecialization(Steerable, veh.specializations) then
			ok = true;
			break;
		end;
		veh = veh.attacherVehicle;
	end
	

	--print("return "..user)
	return veh;

end

function StopBuyStuff:update(dt)
end;

function StopBuyStuff:deleteMap()
end;

function StopBuyStuff:delete()
end;

function StopBuyStuff:mouseEvent(posX, posY, isDown, isUp, button)
end;

function StopBuyStuff:keyEvent(unicode, sym, modifier, isDown)
end;

function StopBuyStuff:draw()
end;

addModEventListener(StopBuyStuff);